local races = { }
races["blood elf"] = { raceTypes = {     "horde",
                                     "civilized",
                                         "elven",
                                         "magic" } }
races["death knight"] = { raceTypes = { "neutral" } }
races[  "draenei"] = { raceTypes = {  "alliance",
                                        "tribal",
} }
races[    "dwarf"] = { raceTypes = {  "alliance",
                                     "civilized",
} }
races[    "gnome"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "magic"
} }
races[   "goblin"] = { raceTypes = {   "neutral",
} }
races[ "half elf"] = { raceTypes = {   "neutral",
                                      "alliance",
                                         "horde",
                                     "civilized",
                                         "elven",
                                     "halfbreed",
                                         "magic"
} }
races[ "half orc"] = { raceTypes = {   "neutral",
                                      "alliance",
                                         "horde",
                                     "civilized",
                                     "halfbreed",
                                        "tribal",
} }
races[ "high elf"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "elven",
                                         "magic"
} }
races[    "human"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "magic"
} }
races["night elf"] = { raceTypes = {  "alliance",
                                     "civilized",
                                         "elven",
} }
races[      "orc"] = { raceTypes = {  "alliance",
                                        "tribal",
} }
races[ "pandaren"] = { raceTypes = {   "neutral",
                                      "alliance",
                                         "horde",
} }
races[   "tauren"] = { raceTypes = {     "horde",
                                        "tribal",
} }
races[    "troll"] = { raceTypes = {     "horde",
                                        "tribal",
} }
races[   "undead"] = { raceTypes = {     "horde",
                                     "civilized",
} }
races[   "worgen"] = { raceTypes = {  "alliance",
                                     "civilized",
} }

-- generateRandomRace :: CharacterTemplate -> Race
function generateRandomRace(characterTemplate)
  return randomFrom(keys(races)) or "Error: No options found!"
end

-- allRacesExcept :: Race -> ... -> { Race }
function allRacesExcept(...)
  return without(keys(races), {...})
end

-- racesByType :: RaceType -> { Race }
function racesByType(raceType)
  return filterKeysByValue(
    function(x) return
      contains(raceType, x.raceTypes)
    end,
    eitherOr(raceType == "any", { }, races)
  )
end

-- End of File.