npcGenerator = { }

local characterTemplates = { }
local currentCharacterTemplateIndex = 0

function GetCurrentCharacterTemplate()
  return characterTemplates[currentCharacterTemplateIndex]
end
  
local function SetTab(i)
  currentCharacterTemplateIndex = i
  printToFrame(GetCurrentCharacterTemplate())
end

local function AddTab()
  local frame = npcGenerator_NPC_Frame

  table.insert(characterTemplates, CharacterTemplate:new())
  
  local tabNumber = table.getn(characterTemplates)
  currentCharacterTemplateIndex = tabNumber
  
  local newTabButton =
    CreateFrame("Button", "tabs_Frame_Tab" .. tabNumber, frame.Tabs, "npcGTabButtonTemplate")
  newTabButton:SetText(tabNumber)
  newTabButton:SetPoint("LEFT", frame.Tabs["TabButton" .. (tabNumber - 1)], "RIGHT", 5, 0)
  newTabButton:SetScript("OnClick", function() SetTab(tabNumber) end)
  
  frame.Tabs["TabButton" .. tabNumber] = newTabButton
  frame.Tabs.AddTabButton:SetPoint("LEFT", newTabButton, "RIGHT", 5, 0)
  
  SetTab(tabNumber)
end

function npcGenerator.OnLoad()
  print "Using npcGenerator 1.0.3a"
  currentCharacterTemplateIndex = 1
  characterTemplates[currentCharacterTemplateIndex] = CharacterTemplate:new()
  --characterTemplate = characterTemplates[currentCharacterTemplateIndex]
  
  local frame = npcGenerator_NPC_Frame
  
  -- Set up the Labels correctly.
  frame.Title.Label:SetText("npcGenerator 1.0.3a")
  frame.Name.Label:SetText("Name")
  frame.Race.Label:SetText("Race")
  frame.Tribe.Label:SetText("Tribe")
  frame.Gender.Label:SetText("Gender")
  frame.Age.Label:SetText("Age")
  frame.Alignment.Label:SetText("Alignment")
  frame.Faith.Label:SetText("Faith")
  frame.Class.Label:SetText("Class")
  frame.Feature.Label:SetText("Prominent Feature")
  frame.Motivations.Label:SetText("Motivations")
  
  -- Hook up events.
  
  -- OnChar scripts to load to characterTemplate.
  frame.Name.EditBox:SetScript("OnChar", readName)
  frame.Race.EditBox:SetScript("OnChar", readRace)
  frame.Tribe.EditBox:SetScript("OnChar", readTribe)
  frame.Gender.EditBox:SetScript("OnChar", readGender)
  frame.Age.EditBox:SetScript("OnChar", readAge)
  frame.Alignment.EditBox:SetScript("OnChar", readAlignment)
  frame.Faith.EditBox:SetScript("OnChar", readFaith)
  frame.Class.EditBox:SetScript("OnChar", readClass)
  frame.Feature.EditBox:SetScript("OnChar", readFeature)
  frame.Motivations.EditBox1:SetScript("OnChar", function() readMotivation(1) end)
  frame.Motivations.EditBox2:SetScript("OnChar", function() readMotivation(2) end)
  frame.Motivations.EditBox2:SetScript("OnChar", function() readMotivation(3) end )
  
  -- OnClick scripts to reroll traits.
  frame.Name.RollButton:SetScript("OnClick", rollName)
  frame.Race.RollButton:SetScript("OnClick", rollRace)
  frame.Tribe.RollButton:SetScript("OnClick", rollTribe)
  frame.Gender.RollButton:SetScript("OnClick", rollGender)
  frame.Age.RollButton:SetScript("OnClick", rollAge)
  frame.Alignment.RollButton:SetScript("OnClick", rollAlignment)
  frame.Faith.RollButton:SetScript("OnClick", rollFaith)
  frame.Class.RollButton:SetScript("OnClick", rollClass)
  frame.Feature.RollButton:SetScript("OnClick", rollFeature)
  frame.Motivations.RollButton1:SetScript("OnClick", function() rollMotivation(1) end )
  frame.Motivations.RollButton2:SetScript("OnClick", function() rollMotivation(2) end )
  frame.Motivations.RollButton3:SetScript("OnClick", function() rollMotivation(3) end )
  
  -- OnClick scripts to clear traits.
  frame.Name.ClearButton:SetScript("OnClick", clearName)
  frame.Race.ClearButton:SetScript("OnClick", clearRace)
  frame.Tribe.ClearButton:SetScript("OnClick", clearTribe)
  frame.Gender.ClearButton:SetScript("OnClick", clearGender)
  frame.Age.ClearButton:SetScript("OnClick", clearAge)
  frame.Alignment.ClearButton:SetScript("OnClick", clearAlignment)
  frame.Faith.ClearButton:SetScript("OnClick", clearFaith)
  frame.Class.ClearButton:SetScript("OnClick", clearClass)
  frame.Feature.ClearButton:SetScript("OnClick", clearFeature)
  frame.Motivations.ClearButton1:SetScript("OnClick", function() clearMotivation(1) end )
  frame.Motivations.ClearButton2:SetScript("OnClick", function() clearMotivation(2) end )
  frame.Motivations.ClearButton3:SetScript("OnClick", function() clearMotivation(3) end )
  
  -- Tabs
  frame.Tabs.TabButton1:SetScript("OnClick", function() SetTab(1) end)
  
  frame.Tabs.AddTabButton:SetScript("OnClick", AddTab)
  
  --[[
  characterTemplate.Motivation = { }
  characterTemplate.getName       = function(self)  return getInternalName(string.lower(box_Name:GetText()))       end
  characterTemplate.getRace       = function(self)  return getInternalName(string.lower(box_Race:GetText()))       end
  characterTemplate.getTribe	  	= function(self)  return getInternalName(string.lower(box_Tribe:GetText()))	   	 end
  characterTemplate.getGender     = function(self)  return getInternalName(string.lower(box_Gender:GetText()))     end
  characterTemplate.getClass      = function(self)  return getInternalName(string.lower(box_Class:GetText()))      end
  characterTemplate.getAlignment  = function(self)  return getInternalName(string.lower(box_Alignment:GetText()))  end
  characterTemplate.getAge        = function(self)  return getInternalName(string.lower(box_Age:GetText()))        end
  characterTemplate.getFaith      = function(self)  return getInternalName(string.lower(box_Faith:GetText()))      end
  characterTemplate.getFeature    = function(self)  return getInternalName(string.lower(box_Feature:GetText()))    end
  characterTemplate.getMotivation = function(self, i) 
    if i == 1 then
      return string.lower(box_Motivation1:GetText())
    elseif i == 2 then
      return string.lower(box_Motivation2:GetText())
    elseif i == 3 then
      return string.lower(box_Motivation3:GetText())
    end
  end
  
  characterTemplate.setName       = function(self, x)  box_Name:SetText(      ucWords(x)) end
  characterTemplate.setRace       = function(self, x)  box_Race:SetText(      ucWords(x)) end
  characterTemplate.setTribe	  	= function(self, x)
    -- Change interface to reflect context, like:
    -- undead uses "subrace";
    -- tauren uses  "tribe";
    local tribeContext = ucFirst(getTribeContext(characterTemplate.getRace()))
    frm_Main.charTribe:SetText(tribeContext)
    -- If a race has no context for this trait, remove the visibility.
    if tribeContext == "" then
      box_Tribe:SetText("")
      --box_Tribe:Hide()
      --frm_Main.rollTribe:Hide()
    else
      --box_Tribe:Show()
      box_Tribe:SetText(ucWords(x))
      --frm_Main.rollTribe:Show()
    end
  end
  characterTemplate.setGender     = function(self, x)  box_Gender:SetText(    ucFirst(x)) end
  characterTemplate.setClass      = function(self, x)  box_Class:SetText(     ucWords(x)) end
  characterTemplate.setAlignment  = function(self, x)  box_Alignment:SetText( ucWords(x)) end
  characterTemplate.setAge        = function(self, x)  box_Age:SetText(       ucWords(x)) end
  characterTemplate.setFaith      = function(self, x)  box_Faith:SetText(     ucWords(   
                                        processSubstitutionString(characterTemplate, x))) end
  characterTemplate.setFeature    = function(self, x)  box_Feature:SetText(   ucFirst(x)) end
  characterTemplate.setMotivation = function(self, i, x) 
    x = processSubstitutionString(characterTemplate, x)
    if i == 1 then
      return box_Motivation1:SetText(ucFirst(x))
    elseif i == 2 then
      return box_Motivation2:SetText(ucFirst(x))
    elseif i == 3 then
      if box_Motivation2:GetText() == "" and x ~= "" then
        return box_Motivation2:SetText(ucFirst(x))
      else
        return box_Motivation3:SetText(ucFirst(x))
      end
    end
  end
  ]]
end

-- End of File.